Index: cpp/frams/genetics/f4/f4_oper.cpp
===================================================================
--- cpp/frams/genetics/f4/f4_oper.cpp	(revision 973)
+++ cpp/frams/genetics/f4/f4_oper.cpp	(revision 974)
@@ -25,5 +25,5 @@
 #define FIELDSTRUCT Geno_f4
 
-static ParamEntry GENO4param_tab[] =
+static ParamEntry geno_f4_paramtab[] =
 {
 	{ "Genetics: f4", 1, F4_COUNT + F4_ADD_COUNT + 1, },
@@ -46,5 +46,5 @@
 {
 	supported_format = '4';
-	par.setParamTab(GENO4param_tab);
+	par.setParamTab(geno_f4_paramtab);
 	par.select(this);
 	par.setDefault();
Index: cpp/frams/genetics/f9/f9_oper.cpp
===================================================================
--- cpp/frams/genetics/f9/f9_oper.cpp	(revision 973)
+++ cpp/frams/genetics/f9/f9_oper.cpp	(revision 974)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2020  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -9,5 +9,5 @@
 
 #define FIELDSTRUCT GenoOper_f9
-static ParamEntry GENOf9param_tab[] =
+static ParamEntry geno_f9_paramtab[] =
 {
 	{ "Genetics: f9", 1, 1, },
@@ -20,5 +20,5 @@
 GenoOper_f9::GenoOper_f9()
 {
-	par.setParamTab(GENOf9param_tab);
+	par.setParamTab(geno_f9_paramtab);
 	par.select(this);
 	par.setDefault();
Index: cpp/frams/genetics/fB/fB_oper.cpp
===================================================================
--- cpp/frams/genetics/fB/fB_oper.cpp	(revision 973)
+++ cpp/frams/genetics/fB/fB_oper.cpp	(revision 974)
@@ -13,5 +13,5 @@
 #define FIELDSTRUCT Geno_fB
 
-static ParamEntry GENOfBparam_tab[] =
+static ParamEntry geno_fB_paramtab[] =
 {
 	{ "Genetics: fB", 3, FB_MUT_COUNT + FB_XOVER_COUNT, },
@@ -33,5 +33,5 @@
 Geno_fB::Geno_fB()
 {
-	par.setParamTab(GENOfBparam_tab);
+	par.setParamTab(geno_fB_paramtab);
 	par.select(this);
 	par.setDefault();
Index: cpp/frams/genetics/fF/fF_oper.cpp
===================================================================
--- cpp/frams/genetics/fF/fF_oper.cpp	(revision 973)
+++ cpp/frams/genetics/fF/fF_oper.cpp	(revision 974)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2019  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2020  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -9,5 +9,5 @@
 
 #define FIELDSTRUCT GenoOper_fF
-static ParamEntry GENOfFparam_tab[] =
+static ParamEntry geno_fF_paramtab[] =
 {
 	{ "Genetics: fF", 1, 1, },
@@ -20,5 +20,5 @@
 GenoOper_fF::GenoOper_fF()
 {
-	par.setParamTab(GENOfFparam_tab);
+	par.setParamTab(geno_fF_paramtab);
 	par.select(this);
 	par.setDefault();
Index: cpp/frams/genetics/fH/fH_oper.cpp
===================================================================
--- cpp/frams/genetics/fH/fH_oper.cpp	(revision 973)
+++ cpp/frams/genetics/fH/fH_oper.cpp	(revision 974)
@@ -11,5 +11,5 @@
 #define FIELDSTRUCT Geno_fH
 
-static ParamEntry GENOfHparam_tab[] =
+static ParamEntry geno_fH_paramtab[] =
 {
 	{ "Genetics: fH", 1, FH_OPCOUNT + FH_ADD_OPCOUNT, },
@@ -28,5 +28,5 @@
 Geno_fH::Geno_fH()
 {
-	par.setParamTab(GENOfHparam_tab);
+	par.setParamTab(geno_fH_paramtab);
 	par.select(this);
 	par.setDefault();
Index: cpp/frams/genetics/fL/fL_oper.cpp
===================================================================
--- cpp/frams/genetics/fL/fL_oper.cpp	(revision 973)
+++ cpp/frams/genetics/fL/fL_oper.cpp	(revision 974)
@@ -9,5 +9,5 @@
 
 #define FIELDSTRUCT Geno_fL
-static ParamEntry GENOfLparam_tab[] =
+static ParamEntry geno_fL_paramtab[] =
 {
 	{"Genetics: fL", 3, FL_OPCOUNT + FL_MUTGROUPSCOUNT + FL_CHG_COUNT + 2 + FL_ADD_COUNT, },
@@ -45,5 +45,5 @@
 Geno_fL::Geno_fL()
 {
-	par.setParamTab(GENOfLparam_tab);
+	par.setParamTab(geno_fL_paramtab);
 	par.select(this);
 	par.setDefault();
Index: cpp/frams/genetics/fS/fS_oper.cpp
===================================================================
--- cpp/frams/genetics/fS/fS_oper.cpp	(revision 973)
+++ cpp/frams/genetics/fS/fS_oper.cpp	(revision 974)
@@ -9,5 +9,5 @@
 
 #define FIELDSTRUCT GenoOper_fS
-static ParamEntry GENOfSparam_tab[] =
+static ParamEntry genooper_fS_paramtab[] =
 		{
 				{"Genetics: fS",            1, FS_OPCOUNT + 5,},
@@ -37,5 +37,5 @@
 GenoOper_fS::GenoOper_fS()
 {
-	par.setParamTab(GENOfSparam_tab);
+	par.setParamTab(genooper_fS_paramtab);
 	par.select(this);
 	par.setDefault();
Index: cpp/frams/genetics/fn/fn_oper.cpp
===================================================================
--- cpp/frams/genetics/fn/fn_oper.cpp	(revision 973)
+++ cpp/frams/genetics/fn/fn_oper.cpp	(revision 974)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2019  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2020  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -22,5 +22,5 @@
 
 #define FIELDSTRUCT GenoOper_fn
-static ParamEntry GENOfnparam_tab[] =
+static ParamEntry genooper_fn_paramtab[] =
 {
 	{ "Genetics: fn", 1, 6, },
@@ -39,5 +39,5 @@
 GenoOper_fn::GenoOper_fn()
 {
-	par.setParamTab(GENOfnparam_tab);
+	par.setParamTab(genooper_fn_paramtab);
 	par.select(this);
 	par.setDefault();