Index: /cpp/frams/config/f0-SDK.def
===================================================================
--- /cpp/frams/config/f0-SDK.def	(revision 975)
+++ /cpp/frams/config/f0-SDK.def	(revision 976)
@@ -147,5 +147,5 @@
 ENDNEUROCLASS
 
-NEUROCLASS(GyroP,Gp,Part Gyroscope,`Tilt sensor. Signal is directly proportional to the tilt angle.\n0=the part X axis is horizontal\n+1/-1=the axis is vertical',0,1,1)
+NEUROCLASS(GyroP,Gpart,Part Gyroscope,`Tilt sensor. Signal is directly proportional to the tilt angle.\n0=the part X axis is horizontal\n+1/-1=the axis is vertical',0,1,1)
 VISUALHINTS(ReceptorClass)
 SYMBOL(`8,7,100,50,90,50,90,40,70,40,80,50,70,60,90,60,90,50,12,43,24,48,24,48,19,38,19,38,24,43,24,43,54,48,54,48,64,43,69,38,64,38,54,43,54,5,63,69,58,74,48,79,38,79,28,74,23,69,1,43,79,43,74,1,23,69,26,66,1,63,69,60,66,1,55,76,53,73,1,31,75,33,72')
@@ -162,10 +162,10 @@
 ENDNEUROCLASS
 
-NEUROCLASS(TouchC,Tc,Touch contact,`Touch sensor.\n-1=no contact\n0=the Part is touching the obstacle\n>0=pressing, value depends on the force applied (not implemented in ODE mode)',0,1,1)
+NEUROCLASS(TouchC,Tcontact,Touch contact,`Touch sensor.\n-1=no contact\n0=the Part is touching the obstacle\n>0=pressing, value depends on the force applied (not implemented in ODE mode)',0,1,1)
 VISUALHINTS(ReceptorClass)
 SYMBOL(`2,7,100,50,90,50,90,40,70,40,80,50,70,60,90,60,90,50,11,75,50,65,50,60,55,55,45,50,55,45,45,40,50,35,50,30,45,25,50,30,55,35,50')
 ENDNEUROCLASS
 
-NEUROCLASS(TouchP,Tp,Touch proximity,`Proximity sensor detecting obstacles along the X axis.\n-1=distance is \'r\' or more\n0=zero distance',0,1,1)
+NEUROCLASS(TouchP,Tproximity,Touch proximity,`Proximity sensor detecting obstacles along the X axis.\n-1=distance is \'r\' or more\n0=zero distance',0,1,1)
 VISUALHINTS(ReceptorClass)
 SYMBOL(`2,7,100,50,90,50,90,40,70,40,80,50,70,60,90,60,90,50,11,75,50,65,50,60,55,55,45,50,55,45,45,40,50,35,50,30,45,25,50,30,55,35,50')
Index: /cpp/frams/config/f0.def
===================================================================
--- /cpp/frams/config/f0.def	(revision 975)
+++ /cpp/frams/config/f0.def	(revision 976)
@@ -147,5 +147,5 @@
 ENDNEUROCLASS
 
-NEUROCLASS(GyroP,Gp,Part Gyroscope,`Tilt sensor. Signal is directly proportional to the tilt angle.\n0=the part X axis is horizontal\n+1/-1=the axis is vertical',0,1,1)
+NEUROCLASS(GyroP,Gpart,Part Gyroscope,`Tilt sensor. Signal is directly proportional to the tilt angle.\n0=the part X axis is horizontal\n+1/-1=the axis is vertical',0,1,1)
 VISUALHINTS(ReceptorClass)
 SYMBOL(`8,7,100,50,90,50,90,40,70,40,80,50,70,60,90,60,90,50,12,43,24,48,24,48,19,38,19,38,24,43,24,43,54,48,54,48,64,43,69,38,64,38,54,43,54,5,63,69,58,74,48,79,38,79,28,74,23,69,1,43,79,43,74,1,23,69,26,66,1,63,69,60,66,1,55,76,53,73,1,31,75,33,72')
@@ -162,10 +162,10 @@
 ENDNEUROCLASS
 
-NEUROCLASS(TouchC,Tc,Touch contact,`Touch sensor.\n-1=no contact\n0=the Part is touching the obstacle\n>0=pressing, value depends on the force applied (not implemented in ODE mode)',0,1,1)
+NEUROCLASS(TouchC,Tcontact,Touch contact,`Touch sensor.\n-1=no contact\n0=the Part is touching the obstacle\n>0=pressing, value depends on the force applied (not implemented in ODE mode)',0,1,1)
 VISUALHINTS(ReceptorClass)
 SYMBOL(`2,7,100,50,90,50,90,40,70,40,80,50,70,60,90,60,90,50,11,75,50,65,50,60,55,55,45,50,55,45,45,40,50,35,50,30,45,25,50,30,55,35,50')
 ENDNEUROCLASS
 
-NEUROCLASS(TouchP,Tp,Touch proximity,`Proximity sensor detecting obstacles along the X axis.\n-1=distance is \'r\' or more\n0=zero distance',0,1,1)
+NEUROCLASS(TouchP,Tproximity,Touch proximity,`Proximity sensor detecting obstacles along the X axis.\n-1=distance is \'r\' or more\n0=zero distance',0,1,1)
 VISUALHINTS(ReceptorClass)
 SYMBOL(`2,7,100,50,90,50,90,40,70,40,80,50,70,60,90,60,90,50,11,75,50,65,50,60,55,55,45,50,55,45,45,40,50,35,50,30,45,25,50,30,55,35,50')
Index: /cpp/frams/genetics/preconfigured.h
===================================================================
--- /cpp/frams/genetics/preconfigured.h	(revision 975)
+++ /cpp/frams/genetics/preconfigured.h	(revision 976)
@@ -28,5 +28,5 @@
 		if (Geno::useValidators(&validators) != NULL)
 			logPrintf("PreconfiguredGenetics", "init", LOG_WARN, "Geno validators already configured");
-		static const char* genactive_classes[] = { "N", "G", "Gp", "T", "S", "*", "|", "@", "M", NULL };
+		static const char* genactive_classes[] = { "N", "G", "Gpart", "T", "S", "*", "|", "@", "M", NULL };
 		NeuroClass::resetActive();
 		NeuroClass::setGenActive(genactive_classes);
Index: /cpp/frams/neuro/neurocls-f0-SDK-factory.h
===================================================================
--- /cpp/frams/neuro/neurocls-f0-SDK-factory.h	(revision 975)
+++ /cpp/frams/neuro/neurocls-f0-SDK-factory.h	(revision 976)
@@ -41,5 +41,5 @@
 #define FIELDSTRUCT NI_GyroP 
 ParamEntry NI_GyroP_tab []={
-{"Part Gyroscope",1, 2 ,"Gp",},
+{"Part Gyroscope",1, 2 ,"Gpart",},
 {"ry",1,0,"rotation.y","f -6.282 6.282 0",FIELD(ry),},
 {"rz",1,0,"rotation.z","f -6.282 6.282 0",FIELD(rz),},
@@ -58,5 +58,5 @@
 #define FIELDSTRUCT NI_TouchC 
 ParamEntry NI_TouchC_tab []={
-{"Touch contact",1, 0 ,"Tc",},
+{"Touch contact",1, 0 ,"Tcontact",},
  {0,0,0,},};
 #undef FIELDSTRUCT
@@ -64,5 +64,5 @@
 #define FIELDSTRUCT NI_TouchP 
 ParamEntry NI_TouchP_tab []={
-{"Touch proximity",1, 3 ,"Tp",},
+{"Touch proximity",1, 3 ,"Tproximity",},
 {"r",1,0,"Range","f 0.0 1.0 1.0",FIELD(range),},
 {"ry",1,0,"rotation.y","f -6.282 6.282 0",FIELD(ry),},
@@ -184,8 +184,8 @@
 setImplementation("Nu",new NI_StdUNeuron); \
 setImplementation("G",new NI_Gyro); \
-setImplementation("Gp",new NI_GyroP); \
+setImplementation("Gpart",new NI_GyroP); \
 setImplementation("T",new NI_Touch); \
-setImplementation("Tc",new NI_TouchC); \
-setImplementation("Tp",new NI_TouchP); \
+setImplementation("Tcontact",new NI_TouchC); \
+setImplementation("Tproximity",new NI_TouchP); \
 setImplementation("S",new NI_Smell); \
 setImplementation("*",new NI_Const); \
Index: /cpp/frams/neuro/neurocls-f0-SDK-library.h
===================================================================
--- /cpp/frams/neuro/neurocls-f0-SDK-library.h	(revision 975)
+++ /cpp/frams/neuro/neurocls-f0-SDK-library.h	(revision 976)
@@ -48,5 +48,5 @@
        static int GyroP_xy[]={83,8,7,100,50,90,50,90,40,70,40,80,50,70,60,90,60,90,50,12,43,24,48,24,48,19,38,19,38,24,43,24,43,54,48,54,48,64,43,69,38,64,38,54,43,54,5,63,69,58,74,48,79,38,79,28,74,23,69,1,43,79,43,74,1,23,69,26,66,1,63,69,60,66,1,55,76,53,73,1,31,75,33,72};   
 static ParamEntry NI_GyroP_tab[]={
-{"Part Gyroscope",1, 2 ,"Gp",},
+{"Part Gyroscope",1, 2 ,"Gpart",},
 
 
@@ -71,5 +71,5 @@
        static int TouchC_xy[]={43,2,7,100,50,90,50,90,40,70,40,80,50,70,60,90,60,90,50,11,75,50,65,50,60,55,55,45,50,55,45,45,40,50,35,50,30,45,25,50,30,55,35,50};   
 static ParamEntry NI_TouchC_tab[]={
-{"Touch contact",1, 0 ,"Tc",},
+{"Touch contact",1, 0 ,"Tcontact",},
 
 
@@ -80,5 +80,5 @@
        static int TouchP_xy[]={43,2,7,100,50,90,50,90,40,70,40,80,50,70,60,90,60,90,50,11,75,50,65,50,60,55,55,45,50,55,45,45,40,50,35,50,30,45,25,50,30,55,35,50};   
 static ParamEntry NI_TouchP_tab[]={
-{"Touch proximity",1, 3 ,"Tp",},
+{"Touch proximity",1, 3 ,"Tproximity",},
 
 