Index: cpp/frams/_demos/f0_variants_test.cpp
===================================================================
--- cpp/frams/_demos/f0_variants_test.cpp	(revision 977)
+++ cpp/frams/_demos/f0_variants_test.cpp	(revision 986)
@@ -106,5 +106,5 @@
 	}
 
-	printf("\nthis example shows how to save a f0 genotype using low-level ParamInterface::saveSingleLine() calls\n");
+	printf("\nThis example shows how to save a f0 genotype using low-level ParamInterface::saveSingleLine() calls\n\n");
 
 	SString f0_skipping_defaults;
@@ -114,6 +114,6 @@
 	save_as_f0(f0_no_skipping_defaults, m, false);
 
-	printf("\n==== with defdata (skips default values) ======\n%s\n", f0_skipping_defaults.c_str());
-	printf("\n==== without defdata (saves all fields) ======\n%s\n", f0_no_skipping_defaults.c_str());
+	printf("\n==== With defdata (skips default values) ======\n%s\n", f0_skipping_defaults.c_str());
+	printf("\n==== Without defdata (saves all fields) ======\n%s\n", f0_no_skipping_defaults.c_str());
 
 	return 0;
@@ -125,7 +125,7 @@
 				  ( format 1 )
 
-this example shows how to save a f0 genotype using low-level ParamInterface::saveSingleLine() calls
+This example shows how to save a f0 genotype using low-level ParamInterface::saveSingleLine() calls
 
-==== with defdata (skips default values) ======
+==== With defdata (skips default values) ======
 m:
 p:
@@ -139,5 +139,5 @@
 
 
-==== without defdata (saves all fields) ======
+==== Without defdata (saves all fields) ======
 m:se=1, Vstyle=
 p:0, 0, 0, m=1, s=1, dn=1, fr=0.4, ing=0.25, as=0.25, rx=0, 0, 0, i=, Vstyle=part
@@ -151,3 +151,2 @@
 
 *************************************************************************/
-
Index: cpp/frams/_demos/loader_test_geno.cpp
===================================================================
--- cpp/frams/_demos/loader_test_geno.cpp	(revision 977)
+++ cpp/frams/_demos/loader_test_geno.cpp	(revision 986)
@@ -19,5 +19,5 @@
 		fprintf(stderr, "Arguments: filename [genotype name or index (1-based) [field name]]\n"
 			"If a genotype is indicated (by providing the optional genotype identifier), the program will output the raw genotype, suitable for Framsticks Theater's genotype viewer mode. If a genotype and a field name is given, the field value (instead of the raw genotype) is printed. If the second argument is not given, the genotype names from the file will be listed.\n"
-			"Example: loader_test walking.gen \"Basic Quadruped\" | theater -g -\n"
+			"Example: loader_test_geno walking.gen \"Basic Quadruped\" | theater -g -\n"
 		);
 		return 1;
@@ -69,14 +69,14 @@
 	// the loop repeats until loaded==NULL, which could be beacause of error
 	if (loader.getStatus() == GenotypeMiniLoader::OnError)
-		fprintf(stderr, "Error: %s", loader.getError().c_str());
+		fprintf(stderr, "Error: %s\n", loader.getError().c_str());
 	// (otherwise it was the end of the file)
 	if (selected)
 	{
-		fprintf(stderr, "genotype %s not found in %s\n", selected, argv[1]);
+		fprintf(stderr, "Genotype %s not found in %s\n", selected, argv[1]);
 		return 2;
 	}
 	else
 	{
-		fprintf(stderr, "\ntotal: %d items, %d characters\n", count, totalsize);
+		fprintf(stderr, "\nTotal: %d items, %d characters\n", count, totalsize);
 		return 0;
 	}
Index: cpp/frams/_demos/multiline_f0_test.cpp
===================================================================
--- cpp/frams/_demos/multiline_f0_test.cpp	(revision 977)
+++ cpp/frams/_demos/multiline_f0_test.cpp	(revision 986)
@@ -39,5 +39,5 @@
 	printf("Converted to f0:\n%s\n", m.getF0Geno().getGenes().c_str());
 
-	printf("\nusing Param::saveMultiLine() to create the \"expanded\" form of the f0 genotype...\n(MultiParamLoader should be able to load this)");
+	printf("\nUsing Param::saveMultiLine() to create the \"expanded\" form of the f0 genotype...\n(MultiParamLoader should be able to load this)");
 
 	StringFILE2 f;
@@ -107,5 +107,5 @@
 
 
-using Param::saveMultiLine() to create the "expanded" form of the f0 genotype...
+Using Param::saveMultiLine() to create the "expanded" form of the f0 genotype...
 (MultiParamLoader should be able to load this)
 ============================