Index: cpp/frams/_demos/f0_variants_test.cpp
===================================================================
--- cpp/frams/_demos/f0_variants_test.cpp	(revision 994)
+++ cpp/frams/_demos/f0_variants_test.cpp	(revision 999)
@@ -98,5 +98,5 @@
 		g.getFormat().c_str(), g.getComment().c_str());
 
-	Model m(g, Model::SHAPE_UNKNOWN);//.getConverted('0'));
+	Model m(g, Model::SHAPETYPE_UNKNOWN);//.getConverted('0'));
 
 	if (!m.isValid())
Index: cpp/frams/_demos/full_props.cpp
===================================================================
--- cpp/frams/_demos/full_props.cpp	(revision 994)
+++ cpp/frams/_demos/full_props.cpp	(revision 999)
@@ -75,5 +75,5 @@
 		loadSString(VirtFILE::Vstdin, gen);
 	Geno g(gen);
-	Model m(g, Model::SHAPE_UNKNOWN);
+	Model m(g, Model::SHAPETYPE_UNKNOWN);
 
 	if (!m.isValid())
Index: cpp/frams/_demos/genoconv_test.cpp
===================================================================
--- cpp/frams/_demos/genoconv_test.cpp	(revision 994)
+++ cpp/frams/_demos/genoconv_test.cpp	(revision 999)
@@ -212,7 +212,7 @@
 	if (using_checkpoints)
 	{ // using Model with checkpoints
-		Model m1(g2, Model::SHAPE_UNKNOWN, false, true);//true=using_checkpoints
+		Model m1(g2, Model::SHAPETYPE_UNKNOWN, false, true);//true=using_checkpoints
 		printf("\nModel built from the converted f%s genotype has %d checkpoints\n", g2.getFormat().c_str(), m1.getCheckpointCount());
-		Model m2(g1, Model::SHAPE_UNKNOWN, false, true);//true=using_checkpoints
+		Model m2(g1, Model::SHAPETYPE_UNKNOWN, false, true);//true=using_checkpoints
 		printf("Model built from the source f%s genotype has %d checkpoints\n", g1.getFormat().c_str(), m2.getCheckpointCount());
 		// accessing individual checkpoint models (if available)
@@ -240,5 +240,5 @@
 		}
 
-		Model mod1(g1, Model::SHAPE_UNKNOWN, 1);
+		Model mod1(g1, Model::SHAPETYPE_UNKNOWN, 1);
 		printf("\nModel map for f%s genotype:\n", g1.getFormat().c_str());
 		ModelDisplayMap dm1(mod1);
@@ -247,5 +247,5 @@
 		mod1combined.addCombined(mod1.getMap(), dm1.getMap());
 		mod1combined.print();
-		Model mod2(g2, Model::SHAPE_UNKNOWN, 1);
+		Model mod2(g2, Model::SHAPETYPE_UNKNOWN, 1);
 		printf("\nModel map for f%s genotype:\n", g2.getFormat().c_str());
 		ModelDisplayMap dm2(mod2);
Index: cpp/frams/_demos/genomanipulation.cpp
===================================================================
--- cpp/frams/_demos/genomanipulation.cpp	(revision 994)
+++ cpp/frams/_demos/genomanipulation.cpp	(revision 999)
@@ -196,10 +196,10 @@
 			printf(cl->getPreferredOutput() ? "and provides meaningful output signal (getPreferredOutput()==1).\n" : "and doesn't provide useful output signal (getPreferredOutput()==0).\n");
 			printf("Instances of '%s' can be used in models having ", cl->getName().c_str());
-			if (cl->getSupportedShapeTypes() == NeuroClass::SUPPORTED_SHAPE_ALL)
+			if (cl->getSupportedShapeTypes() == NeuroClass::SUPPORTED_SHAPETYPE_ALL)
 				printf("any shape types.\n");
 			else
 			{
 				printf("shape types:");
-				for (int i = Model::SHAPE_FIRST; i <= Model::SHAPE_LAST; i++)
+				for (int i = Model::SHAPETYPE_FIRST; i <= Model::SHAPETYPE_LAST; i++)
 					if (cl->isShapeTypeSupported((Model::ShapeType)i))
 						printf(" '%s'", Model::getShapeTypeName((Model::ShapeType)i));
@@ -209,5 +209,5 @@
 			{
 				printf("Instances of '%s' can be attached to Joints having ", cl->getName().c_str());
-				if (cl->getSupportedJointShapes() == NeuroClass::SUPPORTED_JOINT_ALL)
+				if (cl->getSupportedJointShapes() == NeuroClass::SUPPORTED_JOINTSHAPE_ALL)
 					printf("any shapes");
 				else
@@ -311,5 +311,5 @@
 		g.getFormat().c_str(), g.getComment().c_str());
 
-	Model m(g, Model::SHAPE_UNKNOWN);//.getConverted('0'));
+	Model m(g, Model::SHAPETYPE_UNKNOWN);//.getConverted('0'));
 
 	if (!m.isValid())
Index: cpp/frams/_demos/geometry/geometrytestutils.cpp
===================================================================
--- cpp/frams/_demos/geometry/geometrytestutils.cpp	(revision 994)
+++ cpp/frams/_demos/geometry/geometrytestutils.cpp	(revision 999)
@@ -63,5 +63,5 @@
 		if ((genoIndex == count) || (strcmp(genotype->name.c_str(), genoName) == 0))
 		{
-			Model model(genotype->genotype, Model::SHAPE_UNKNOWN);
+			Model model(genotype->genotype, Model::SHAPETYPE_UNKNOWN);
 
 			if (!model.isValid())
Index: cpp/frams/_demos/multiline_f0_test.cpp
===================================================================
--- cpp/frams/_demos/multiline_f0_test.cpp	(revision 994)
+++ cpp/frams/_demos/multiline_f0_test.cpp	(revision 999)
@@ -30,5 +30,5 @@
 		g.getFormat().c_str(), g.getComment().c_str());
 
-	Model m(g, Model::SHAPE_UNKNOWN);//.getConverted('0'));
+	Model m(g, Model::SHAPETYPE_UNKNOWN);//.getConverted('0'));
 
 	if (!m.isValid())
Index: cpp/frams/_demos/neuro_layout_test.cpp
===================================================================
--- cpp/frams/_demos/neuro_layout_test.cpp	(revision 994)
+++ cpp/frams/_demos/neuro_layout_test.cpp	(revision 999)
@@ -104,5 +104,5 @@
 	Geno g(gen);
 	if (!g.isValid()) { puts("invalid genotype"); return 5; }
-	Model m(g, Model::SHAPE_UNKNOWN);
+	Model m(g, Model::SHAPETYPE_UNKNOWN);
 	if (!m.getNeuroCount()) { puts("no neural network"); return 1; }
 	printf("%d neurons,", m.getNeuroCount());
Index: cpp/frams/_demos/neuro_test.cpp
===================================================================
--- cpp/frams/_demos/neuro_test.cpp	(revision 994)
+++ cpp/frams/_demos/neuro_test.cpp	(revision 999)
@@ -77,5 +77,5 @@
 	Geno g(gen);
 	if (!g.isValid()) { puts("invalid genotype"); return 5; }
-	Model m(g, Model::SHAPE_UNKNOWN);
+	Model m(g, Model::SHAPETYPE_UNKNOWN);
 	if (!m.getNeuroCount()) { puts("no neural network"); return 1; }
 	printf("%d neurons,", m.getNeuroCount());
Index: cpp/frams/_demos/shapeconvert.cpp
===================================================================
--- cpp/frams/_demos/shapeconvert.cpp	(revision 994)
+++ cpp/frams/_demos/shapeconvert.cpp	(revision 999)
@@ -67,5 +67,5 @@
 		loadSString(VirtFILE::Vstdin, gen);
 	Geno g(gen);
-	Model m(g, Model::SHAPE_UNKNOWN);
+	Model m(g, Model::SHAPETYPE_UNKNOWN);
 
 	if (!m.isValid())
@@ -75,5 +75,5 @@
 	}
 
-	if (m.getShapeType() != Model::SHAPE_BALL_AND_STICK)
+	if (m.getShapeType() != Model::SHAPETYPE_BALL_AND_STICK)
 	{
 		logPrintf("", "shapeconvert", LOG_ERROR, "Only ball-and-stick models can be converted");